Index: asterisk/rtp.c
===================================================================
RCS file: /usr/cvsroot/asterisk/rtp.c,v
retrieving revision 1.136
diff -u -r1.136 rtp.c
--- asterisk/rtp.c	18 Jun 2005 17:13:01 -0000	1.136
+++ asterisk/rtp.c	9 Jul 2005 20:45:48 -0000
@@ -1076,37 +1076,38 @@
 	
 	/* Get a pointer to the header */
 	rtpheader = (unsigned int *)data;
-	rtpheader[0] = htonl((2 << 30) | (1 << 23) | (payload << 16) | (rtp->seqno++));
+	rtpheader[0] = htonl((2 << 30) | (1 << 23) | (payload << 16) | (rtp->seqno));
 	rtpheader[1] = htonl(rtp->lastdigitts);
 	rtpheader[2] = htonl(rtp->ssrc); 
 	rtpheader[3] = htonl((digit << 24) | (0xa << 16) | (0));
-	for (x=0;x<6;x++) {
-		if (rtp->them.sin_port && rtp->them.sin_addr.s_addr) {
-			res = sendto(rtp->s, (void *) rtpheader, hdrlen + 4, 0, (struct sockaddr *) &rtp->them, sizeof(rtp->them));
-			if (res < 0) 
-				ast_log(LOG_ERROR, "RTP Transmission error to %s:%d: %s\n",
-					ast_inet_ntoa(iabuf, sizeof(iabuf), rtp->them.sin_addr),
-					ntohs(rtp->them.sin_port), strerror(errno));
-			if (rtp_debug_test_addr(&rtp->them))
-				ast_verbose("Sent RTP packet to %s:%d (type %d, seq %d, ts %d, len %d)\n",
-					    ast_inet_ntoa(iabuf, sizeof(iabuf), rtp->them.sin_addr),
-					    ntohs(rtp->them.sin_port), payload, rtp->seqno, rtp->lastdigitts, res - hdrlen);
-		}
-		/* Clear marker bit and increment seqno */
-		rtpheader[0] = htonl((2 << 30) | (payload << 16) | (rtp->seqno++));
-		/* For the last three packets, set the duration and the end bit */
-		if (x == 2) {
-#if 0
-			/* No, this is wrong...  Do not increment lastdigitts, that's not according
-			   to the RFC, as best we can determine */
-			rtp->lastdigitts++; /* or else the SPA3000 will click instead of beeping... */
-#endif			
-			rtpheader[1] = htonl(rtp->lastdigitts);
-			/* Make duration 800 (100ms) */
-			rtpheader[3] |= htonl((800));
-			/* Set the End bit */
-			rtpheader[3] |= htonl((1 << 23));
-		}
+
+	for (x=0;x<6;x++,rtp->seqno++) {
+
+	  /* Clear marker bit after the first packet */
+	  if(x==1) {
+	    rtpheader[0] = htonl((2 << 30) | (payload << 16) | (rtp->seqno));
+	  }
+
+	  /* For the last three packets, set the duration and the end bit */
+	  if(x==3) {
+	    /* Make duration 800 (100ms) */
+	    rtpheader[3] |= htonl((800));
+	    /* Set the End bit */
+	    rtpheader[3] |= htonl((1 << 23));
+	  }
+
+	  /* Send the packet */
+	  if (rtp->them.sin_port && rtp->them.sin_addr.s_addr) {
+	    res = sendto(rtp->s, (void *) rtpheader, hdrlen + 4, 0, (struct sockaddr *) &rtp->them, sizeof(rtp->them));
+	    if (res < 0) 
+	      ast_log(LOG_ERROR, "RTP Transmission error to %s:%d: %s\n",
+		      ast_inet_ntoa(iabuf, sizeof(iabuf), rtp->them.sin_addr),
+		      ntohs(rtp->them.sin_port), strerror(errno));
+	    if (rtp_debug_test_addr(&rtp->them))
+	      ast_verbose("Sent RTP packet to %s:%d (type %d, seq %d, ts %d, len %d)\n",
+			  ast_inet_ntoa(iabuf, sizeof(iabuf), rtp->them.sin_addr),
+			  ntohs(rtp->them.sin_port), payload, rtp->seqno, rtp->lastdigitts, res - hdrlen);
+	  }
 	}
 	/* Increment the digit timestamp by 120ms, to ensure that digits
 	   sent sequentially with no intervening non-digit packets do not
